#if !defined(GROUPCODE_H)
#define GROUPCODE_H

#include <iostream>
#include <QPoint>
#include <QRect>
#include <QObject>
//#include <afxtempl.h>

#define  MAX_LINESTRING 2048  //һַ
#define OriginPoint (0, 0)


#define MIN_SAMEPOINTDISTANCE  0.001  //λǰļһ£жϵǷΪͬһ㣬X/YСֵΪͬ  20181009 0.15Ϊ0.01,QPointDataе==ж
                                     //20221102 XQ ֵ0.01Ϊ0.001 廨ȱȽϸߣںСԲ
//#define MAX_SAMEPOINTDISTANCE  0.15  //20190221 Ѱұպʱ, ж߶˵Ϊͬһ, λǰļһ 0.15V9һ
#define MIN_MAXDISTANCE  1  //λǰļһ£ ֵ, ж߾룬жǷΪͬһ
#define V10_G_MAX_SPLINE_ERROR      0.05   //ߵıƽ,λ:mm
#define V10_G_MAX_SPLINECTRL_ERROR  0.1    //߿Ƶıƽ,λ:mm
//////////////////////////////////////////////////////////////////////////
//
#define  POINT_TURN    0  //ת۵
#define  POINT_CURVE   1  //ߵ
#define  POINT_ARC     2  //Բ
#define  POINT_SPILINE 3   //

//
#define CODE_NULL        -1
#define CODE_POLYLINE     0
#define CODE_LWPOLYLINE   1
#define CODE_LINE         2
#define CODE_MLINE        3
#define CODE_SPILINE      4
#define CODE_TEXT         5
#define CODE_MTEXT        6
#define CODE_ARC          7
#define CODE_CIRCLE       8
#define CODE_ELLIPSE      9
#define CODE_DIMENSION    10

//λ
#define CONST_MM    0
#define CONST_INCH  1

//////////////////////////////////////////////////////////////////////////
class CTextDataList;
class CPDSNurbsPointList;

class QPointData : public QObject
{
public:
  double m_dX;
  double m_dY;  //

  QString m_strLayer;  //  AutoCADļвΪַ
  /*
  
    =POINT_TURN ת۵㣻
    =POINT_CURVEߵ㣻
    =POINT_ARCԲ㣻
    =POINT_SPILINE
    Ĭת۵
  */
  int m_iType;

  int m_iGradeID;  //ID

public:
  QPointData(void);
  QPointData(QPointData& a);
  ~QPointData(void);

  void operator=(QPointData& a);
  bool operator==(QPointData& a);  //жϵǷȣΧ MIN_SAMEPOINTDISTANCE
  bool operator!=(QPointData& a);  //Χ MIN_SAMEPOINTDISTANCE
  void Initial(void);

  //20190221 жǷȣոķΧж
  //
  //  a
  //  dMaxValue Χ
  //ֵ
  //  =true  =false
  bool Equal(QPointData&a, double dMaxValue);

  //Ϣƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  QPoint GetIntPoint();

  //÷ID
  //
  //  listPointGrade ҵ
  void SetGradeID(CTextDataList &listPointGrade);
};

class CCurveNotchInforList;

class QPointDataList : public QList<QPointData,QPointData&>
{
public:
  QPointDataList& operator=(QPointDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  QPointData& operator[](int iIndex);

  //ߵеϢƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õ
  QRect GetRect();

  void GetIntPoint(QList<QPoint, QPoint> &listPoint);

  //÷ID
  //
  //  listPointGrade ҵ
  void SetGradeID(CTextDataList &listPointGrade);

  //õ
  //
  //  listTurnPoint ת۵
  //  listCurvePoint ߵ
  void SetPointType(QPointDataList &listTurnPoint, QPointDataList &listCurvePoint);

  //Ҹ
  //
  // PointData 
  //ֵ
  // =true ҵ=falseûҵ
  bool FindSamePoint(QPointData PointData);

  //ÿһתһ
  void GetCurveInforList(CCurveNotchInforList &listCurveInfor);

  //20201021 XQ Ƴڵͬ㣬ͷβ㲻
  void RemoveSamePoint();
};

class CGroupCode : public QObject
{
public:
  //Auto CADɫͶʹ÷űʾ

  int m_iType;  //CODE_NULL....
  QString m_strLayer;  //
  QString m_strColor;  //ɫ ΪգΪɫ
  QString m_strViewCurveType;  //ͨҶӦõ..... ΪձʾĬ
public:
  CGroupCode(void);
  CGroupCode(CGroupCode& a);
  ~CGroupCode(void);

  void operator=(CGroupCode& a);
  void Initial(void);

  void CopyData(CGroupCode &a);

};

//////////////////////////////////////////////////////////////////////////
//Ϣ
class CCurveInfor : public CGroupCode
{
public:
  QPointDataList m_listCtrlCurve;
  bool m_bClose;  //=true պߣ=false 

  //Ŀǰֻm_iCurveTypeΪCODE_SPILINEʱЧ
  int m_iCtrlPointType;  //= 0ʾ߾Ƶ㣻=1 ; =2 ʾ CODE_SPILINEѾ Ĭ1
  QList<double, double> m_listdCode40;  //Ϊ40ֵ 
  QList<double, double> m_listdCode41;  //Ϊ41ֵ Ȩֵ ΪȨֵΪ1
  QPointDataList m_listReadCurve;  //Ŷϵ, κδʲôݴʲô

  QList<QPoint, QPoint> m_listPoint; //ʵʵ
public:
  CCurveInfor(void);
  CCurveInfor(CCurveInfor& a);
  ~CCurveInfor(void);

  void operator=(CCurveInfor& a);
  void Initial(void);

  //ߵеϢƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õ
  QRect GetRect();

  //תͷβ㣬βͷ
  void Reverse();

  //õպߵĵ(еX/Yȡƽֵ)
  void GetMiddlePoint(QPointData &PDMiddle);

  //CODE_SPILINEĿƵ
  void CalcuateSPlineCurve();

  //߿Ƶֶ
  void Segmentation(QList<QPointDataList, QPointDataList&> &listPointDataList);

  //еĵͺͷID
  //
  //  listPointGrade 
  //  listTurnPointLayer ת۵
  //  listCurvePointLayer ߵ
  void SetPointTypeGradeID(CTextDataList &listPointGrade, QPointDataList &listTurnPointLayer, QPointDataList &listCurvePointLayer);

  //ʵʵ
  //[] iDPMM Ŵ
  void CalcuateActualPoint(int iDPMM);

  //20200219 XQ ȡʵʵ
  //:
  //  listCurve ʵʵ
  //˵:
  //  øú֮ǰüʵʵ
  void GetCurve(QList<QPoint, QPoint> &listCurve);

  //20201021 XQ Ƴڵͬ㣬ֻԿƵ
  void RemoveSamePoint();
private:

  //ʵʵ
  //[] iDPMM Ŵ
  //[] listCtrlPoint Ƶ ֻһͣͷβ⣬мֻһת۵㣬ߵ㣬Բ㣩
  //[] listPointʵʵ
  void CalcuateCurveInfor(int iDPMM, QPointDataList &listCtrlPoint, QList<QPoint, QPoint> &listPoint);

  //
  // [] listPoint ĸƵ㣬
  // [] listCtrl ƽĿƵ
  //ֵ
  //  =ture ɹ=false ʧ
  //˵
  // ǷɹͷΪת۵㣬мΪƵ
  bool CalculateSPLine(QPointDataList &listPoint, QPointDataList &listCtrl);

  //õ
  //
  //  listPoint Ҫĵ
  //  bTurn =trueе㴦Ϊת۵㣻=falseͷΪת۵㣬мΪߵ
  void SetPointType(QPointDataList &listPoint, bool bTurn);

  //㷽 t*t*t*ptPoint0+2*t*t*(1-t)ptPoint1+3*t*(1-t)*(1-t)ptPoint2+(1-t)*(1-t)*(1-t)ptPoint3
  //[] ptPoint0ptPoint1ptPoint2ptPoint3̵ĸ֪
  //[] dPro ֵtֵֵΧ01
  //ֵ
  //  ̵Ľ
  QPointData CalcuateEquation(QPointData ptPoint0, QPointData ptPoint1, QPointData ptPoint2, QPointData ptPoint3, double dPro);

  //QPointDataתCPDSNurbsPoint
  void PointDataToNurbsPoint(QPointDataList &listPointData, CPDSNurbsPointList &listNurbsPoint);

  //CPDSNurbsPointתQPoint
  void NurbsPointToPoint(CPDSNurbsPointList &listNurbsPoint, int iDPMM, QList<QPoint, QPoint>  &listPoint);

  //QPointתQPointData
  void PointToPointData(QList<QPoint, QPoint>  &listPoint, int iDPMM,  QPointDataList &listPointData);

  //listDataPointеͽlistDataPointlistRealPointֶ
  void NurbsSegmention(CPDSNurbsPointList &listDataPoint, CPDSNurbsPointList &listRealPoint, int iDPMM, 
                       CArray < QList <QPoint, QPoint> , QList <QPoint, QPoint> >  &arCtrlPoint, CArray < QList <QPoint, QPoint> , QList <QPoint, QPoint> >  &arRealPoint, bool &bClose);
};

//////////////////////////////////////////////////////////////////////////
//Ϣ
class CNotchInfor : public QObject
{
public:
  QPointData m_ptNotch;
  int m_iNotchLayer;  //ڲ  =4 I; = 80 T;= 81 Box =82 V; =83 U;
  double m_dNotchWidth;
  bool m_bNotchWidth;  //=true ݴ=false ϵͳĬݴ
  double m_dNotchDepth;
  bool m_bNotchDepth;  //=true ݴ=false ϵͳĬݴ
  double m_dNotchAngle;
  bool m_bAngle;  //=true ʾǶȿã=false ʾǶȲ

public:
  CNotchInfor(void);
  CNotchInfor(CNotchInfor& a);
  ~CNotchInfor(void);
  void operator=(CNotchInfor& a);
  void Initial(void);

  //λƫ,תͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õID
  void SetGradeID(CTextDataList &listGradePoint);
};

class CNotchInforList : public QList<CNotchInfor,CNotchInfor&>
{
public:
  CNotchInforList& operator=(CNotchInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CNotchInfor& operator[](int iIndex);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õID
  void SetGradeID(CTextDataList &listGradePoint);
};

//////////////////////////////////////////////////////////////////////////
//߼ϸϢ磺ڣ
class CCurveNotchInfor : public QObject
{
public:
  CCurveInfor m_CurveInfor;

  CNotchInforList m_listNotch;

public:
  CCurveNotchInfor(void);
  CCurveNotchInfor(CCurveNotchInfor& a);
  ~CCurveNotchInfor(void);
  void operator=(CCurveNotchInfor& a);
  void Initial(void);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //еĵͺͷID
  //
  //  listPointGrade 
  //  listTurnPointLayer ת۵
  //  listCurvePointLayer ߵ
  void SetPointTypeGradeID(CTextDataList &listPointGrade, QPointDataList &listTurnPointLayer, QPointDataList &listCurvePointLayer);

  //õ
  QRect GetRect();

  //תͷβ㣬βͷ
  void Reverse();

  //20200219 XQ ȡʵʵ
  //:
  //  listCurve ʵʵ
  //˵:
  //  øú֮ǰüʵʵ
  void GetCurve(QList<QPoint, QPoint> &listCurve);
};

class CCurveNotchInforList: public QList<CCurveNotchInfor,CCurveNotchInfor&>
{
public:
  CCurveNotchInforList& operator=(CCurveNotchInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CCurveNotchInfor& operator[](int iIndex);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //еĵͺͷID
  //
  //  listPointGrade 
  //  listTurnPointLayer ת۵
  //  listCurvePointLayer ߵ
  void SetPointTypeGradeID(CTextDataList &listPointGrade, QPointDataList &listTurnPointLayer, QPointDataList &listCurvePointLayer);

  //õ
  QRect GetRect();

  //õе
  void GetAllPointData(QPointDataList &listPointData);

  //20200220 XQ õмڵ
  void GetAllNotchPoint(CNotchInforList &listNotchInfor);

  //õʵʵ
  //[] bClose =true պ
  //[] listCurve ʵʵ
  //˵
  // ˳ ȥͬ
  void GetCurve(QList<QPoint, QPoint> &listCurve, bool bClose);

  //ʵʵ
  //[] iDPMM Ŵ
  void CalcuateActualPoint(int iDPMM);

  //20201021 XQ Ƴڵͬ㣬ͷβ㲻
  void RemoveSamePoint();
};
//////////////////////////////////////////////////////////////////////////
//
class CTextData : public CGroupCode
{
public:
  QPointData m_PointData;
  QString m_strText;
  bool m_bReadHeight;
  double m_dHeight;
  double m_dAngle;
public:

  CTextData(void);
  CTextData(CTextData& a);
  ~CTextData(void);
  bool operator==(CTextData& a);
  void operator=(CTextData& a);
  void Initial(void);

  //λƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õ
  QRect GetRect();

  //õID
  void SetGradeID(CTextDataList &listGradePoint);

};
class CTextDataList : public QList<CTextData,CTextData&>
{
public:
  CTextDataList& operator=(CTextDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CTextData& operator[](int iIndex);

  //λƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õ
  QRect GetRect();

  //õID
  void SetGradeID(CTextDataList &listGradePoint);

  //Ҹַ
  //
  // PointData
  //
  //  TextData ҵı ֵΪtrueЧ
  //ֵ
  // =true ҵ=falseûҵ
  bool FindSamePointText(QPointData PointData, CTextData &TextData);
};

//////////////////////////////////////////////////////////////////////////
//Ϣ
class  CDrillInfor : public QObject
{
public:
  QPointData m_ptDrill;
  bool m_bRadius;  //=true ݴף=false ϵͳĬݴ
  double m_dRadius;
  int m_iCommand;  // =0 GP_DCM_DRILL = 1 GP_DCM_DRAW

public:
  CDrillInfor(void);
  CDrillInfor(CDrillInfor& a);
  ~CDrillInfor(void);
  void operator=(CDrillInfor& a);
  void Initial(void);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õID
  void SetGradeID(CTextDataList &listGradePoint);
};

class CDrillInforList : public QList<CDrillInfor,CDrillInfor&>
{
public:
  CDrillInforList& operator=(CDrillInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CDrillInfor& operator[](int iIndex);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  void SetScale(double dScale);

  //õID
  void SetGradeID(CTextDataList &listGradePoint);
};
//////////////////////////////////////////////////////////////////////////
//INSERTʶϢ
class CInsertData : public CGroupCode
{
public:
  QString m_strBlockName;
  QPointData m_InsertPoint;
  double m_dScaleX;  //20191012 XQ
  double m_dScaleY;
  double m_dRotateAngle;  //תǶ

public:
  CInsertData(void);
  CInsertData(CInsertData& a);
  ~CInsertData(void);
  bool operator==(CInsertData& a);
  void operator=(CInsertData& a);
  void Initial(void);

};

class CInsertDataList : public QList<CInsertData,CInsertData&>
{
public:
  CInsertDataList& operator=(CInsertDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CInsertData& operator[](int iIndex);

  //ݸĿҳӦĿ
  //[] strBlockName 
  //[] InsertData λ
  //ֵ
  //  ҵλã ûҵNULL
  POSITION FindBlockName(QString strBlockName, CInsertData &InsertData);
};

//////////////////////////////////////////////////////////////////////////
class CCurveNotchInforList;

//ѰֽõĽṹ
class CCloseCurveInfor : public QObject
{
public:
  CCurveNotchInforList m_listCurveInfor;

  double m_dAreaRect;  //ھ
public:
  CCloseCurveInfor(void);
  CCloseCurveInfor(CCloseCurveInfor& a);
  ~CCloseCurveInfor(void);
  void operator=(CCloseCurveInfor& a);
  void Initial(void);

  void GetAreaRect();

  void GetHeadTail(QPointData &PointDataH, QPointData &PointDataT);

  //õ
  //˵
  //  еm_listCurveInforŵһ
  void GetPointList(QPointDataList &listPointData);

  //õպߵĵ(еX/Yȡƽֵ)
  void GetMiddlePoint(QPointData &PDMiddle);

};

class CCloseCurveInforList: public QList<CCloseCurveInfor,CCloseCurveInfor&>
{
public:
  CCloseCurveInforList& operator=(CCloseCurveInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CCloseCurveInfor& operator[](int iIndex);

  //б
  POSITION FindMaxAreaRect();
};

/////////////////////////////////////////////////////////////////////////
//ֽ, Ҫڶֽ֮ʱõ

//˵
//ûSetRotateOffsetScaleԭ вҪݽƫ->ת->ŴС ƫƺת m_ptOffsetm_dAngle
class CPatternBlock : public QObject
{
public:
  QString m_strPatternName;  //ֽ
  QString m_strSizeName;  //
  QString m_strComment;   //עCOMMENT/ANNOTATION
  CStringArray m_arrMaterial;  //
  CUIntArray m_arrQuantity;  //ƬϷ  Quantity:<R,L>
  CUIntArray m_arrLQuantity;  //ƬϷ  Quantity:<R,L>
  //m_arrQuantity, m_arrLQuantityСһ

  bool m_bFlip;  //תϢ =true ת
  double m_dRotation;  //б Rotation<0...360>
  bool m_bFold;  //۵ Fold:<Y/N> =true ۵
  double m_dTilt;  //бǶ Tilt:<+/-0..90>

  CCurveNotchInforList m_listBorder;  //
  CCurveNotchInforList m_listSeam;  //
  CCurveNotchInforList m_listAssistantCurve;  //
  CTextDataList m_listText;  //ַ

  //AutoCADļ
  //CNotchInforList m_listNotch;  //
  CDrillInforList m_listDrill;  //

  CCurveNotchInfor m_GrainLine;  //
  CCurveNotchInfor m_SymmetryLine;  //Գ

  //ֻڶASTM/AAMA
  CCurveNotchInfor m_GradeLine;  //

  //ֽƫƺתǶȣתΪQPoint(0,0), ˮƽΪ
  QPointData m_ptOffset;
  double m_dAngle;

public:
  CPatternBlock(void);
  CPatternBlock(CPatternBlock& a);
  ~CPatternBlock(void);
  void operator=(CPatternBlock& a);
  void Initial(void);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //
  //
  //dScale ŴС
  void SetScale( double dScale);

  QRect GetRect();

  //ʵʵ
  //[] iDPMM Ŵ
  void CalcuateActualPoint(int iDPMM);

private:
  //
  void CopyPatternInfor(CPatternBlock& a);

};

class CPatternBlockList : public QList<CPatternBlock,CPatternBlock&>
{
public:
  CPatternBlockList& operator=(CPatternBlockList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CPatternBlock& operator[](int iIndex);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪQPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //
  //
  //dScale ŴС
  void SetScale(double dScale);

  QRect GetRect();

  //кV10ϵͳдֽ
  //õбֽĺ
  //
  //  listAllSizeName Сthisбһ ˳Ҳһ
  void GetAllSizeName(QList<QString,QString> &listAllSizeName);

  //ҸƵĺ͵беλ
  //
  //  strSizeName 
  //ֵ
  // беλã ҵĵһ NULLʾû
  POSITION FindSizeName(QString strSizeName);

  //ʵʵ
  //[] iDPMM Ŵ
  void CalcuateActualPoint(int iDPMM);
};

//һַ
//[] bReadWindowText =true س0x0Aʾģ=false س0x0D0A
//[] iMaxCount һĳ
//[] fFile ļ
//ֵ
//  
QString GetALineOfFile(bool bReadWindowText, int iMaxCount, FILE *fFile);

//ַ
//[] bReadWindowText =true س0x0Aʾģ=false س0x0D0A
//[] fFile ļ
//[] strString1/strString2 
void ReadTwoLineString(bool bReadWindowText, FILE *fFile, QString &strString1, QString &strString2);

//жϸַǷΪһݿĿʼʶ(strValue1ǷΪ0strValue2ǷΪ POLYLINE, LINE...)
//[] strValue1 Ҫжϵַ
//[] strValue2 Ҫжϵַ
//ֵ
//  =true ǣfalse 
//˵
//strValue1ΪյĻжϲΪ жǷΪ0 Ϊ0strValue2ж
bool JudgeCode(QString strValue1, QString strValue2);

#endif
