// PDSUnit.h

#if !defined(PDSUnit_h)
#define PDSUnit_h

//йسȵλȵ˵:1ڹƵĳ,뾫Ϊ0.01mm,ʾ߾Ϊ0.01mm
//                         2ӢƷĳ,뾫Ϊ1/2048Ӣ,ʾ߾Ϊ1/2048Ӣ
//                         3ӢСĳ,뾫Ϊ0.001Ӣ,ʾ߾Ϊ0.001Ӣ

//ȵλ
#define UNIT_INCHFRACTION      0    //ӢƷ
#define UNIT_INCHDECIMA        1    //ӢС
#define UNIT_CENTIMETER        2    //cm
#define UNIT_MILLIMETER        3    //mm
#define UNIT_CHINACUN          4    //ƴ

//ȷ
//ʹӢƷʱľȷ,=1 ,=2 2,=4 4,=8 8,
//                       =16 16,=32 32,=64 64,=128 128,
//                       =256 256,=512 ,=1024 1024,=2048 2048.
//ʹӢС(cm,mm)ʱľȷ,=1 ȷλ,=10 ȷ0.1,=100 ȷ0.01,
//                                    =1000 ȷ0.001,=10000 ȷ0.0001
#define PRECISION_INTEGER          1      //
#define PRECISION_FRACTION2        2      //2
#define PRECISION_FRACTION4        4      //4
#define PRECISION_FRACTION8        8      //8
#define PRECISION_FRACTION16       16     //16
#define PRECISION_FRACTION32       32     //32
#define PRECISION_FRACTION64       64     //64
#define PRECISION_FRACTION128      128    //128
#define PRECISION_FRACTION256      256    //256
#define PRECISION_FRACTION512      512    //512
#define PRECISION_FRACTION1024     1024   //1024
#define PRECISION_FRACTION2048     2048   //2048
#define PRECISION_DECIMAL10        10     //ȷ0.1
#define PRECISION_DECIMAL100       100    //ȷ0.01
#define PRECISION_DECIMAL1000      1000   //ȷ0.001
#define PRECISION_DECIMAL10000     10000  //ȷ0.0001

//ʹӢʱ,inchʾַ
//:
//  iLength 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  inchΪλַ
CString InchString(int iLength,int idpmm,int iUnit,int iPrecision);

//cmʾַ
//:
//  iLength 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  cmΪλַ
CString CentimetreString(int iLength,int idpmm,int iPrecision);

//mmʾַ
//:
//  iLength 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  mmΪλַ
CString MillimetreString(int iLength,int idpmm,int iPrecision);

//Դʾַ
//:
//  iLength 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  ԴΪλַ
CString ChinaCunString(int iLength,int ilpmm,int iPrecision);

//ڲλ1/idpmmΪλĳֵתΪԵǰʹʽĳֵַ
//:
//  iLength 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  ԵǰʹʽΪλַ
CString InternalUnitToString(int iLength,int idpmm,int iUnit,int iPrecision);

//ڲλ(1/idpmm)*(1/idpmm)2ΪλֵתΪ
//ԵǰʹõĶλַ
//:
//  dArea (1/idpmm)*(1/idpmm)2Ϊλֵ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//  iPrecision  ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  ԵǰʹõĶλַ
CString AreaToString(double dArea,int idpmm,int iUnit,int iPrecision);

//InchΪλִתڲλ1/idpmmΪλ
//:
//  strInch inchΪλַ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//  bEnableDefaultDenominator =true δĸʱʹiPrecisionָķĸ
//  iPrecision ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  1/idpmmΪλֵ
int InchStrToInternalUnit(CString strInch,int idpmm,int iUnit,BOOL bEnableDefaultDenominator,int iPrecision);

//ԵǰʹʽĳַתΪ1/idpmmΪλĳֵ
//:
//  string ԵǰʹʽΪλַ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//  bEnableDefaultDenominator =true δĸʱʹiPrecisionָķĸ
//  iPrecision ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  1/idpmmΪλֵ
int StringToInternalUnit(CString string,int idpmm,int iUnit,BOOL bEnableDefaultDenominator,int iPrecision);

//ӢʽַתС
//:
//  string  Ӣʽַ
//  bEnableDefaultDenominator =true δĸʱʹiPrecisionָķĸ
//  iPrecision ȷ("PDSUnit.h"ļھȷȵĺ궨)
//ֵ:
//  ӢСֵ
double InchFractionStringToDecimal(CString string,BOOL bEnableDefaultDenominator,int iPrecision);

//ַתС
//:
//  string  ʾַ
//ֵ:
//  Сֵ
double FractionStringToDecimal(CString string);

//ȡõǰʹõĳȵλַ
//:
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//ֵ:
//  In. iUnit=UNIT_INCHFRACTION
//  In. iUnit=UNIT_INCHDECIMA
//  cm  iUnit=UNIT_CENTIMETER
//  mm  iUnit=UNIT_MILLIMETER
CString GetUnitStr(int iUnit);

//20111130 ԵǰʹʽĳתΪ1/idpmmΪλĳֵ
//:
//  dValue ԵǰʹʽΪλֵ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
//ֵ:
//  1/idpmmΪλֵ
//˵
//  dValueĵλiUnitһ£dValueiUnitλõֵ
int DoubleToInternalUnit(double dValue, int idpmm, int iUnit);

//20111130 ڲλ1/idpmmΪλĳֵתΪԵǰʹʽĳֵĸ
//:
//  iValue 1/idpmmΪλֵ
//  idpmm ÿ׵߼λ
//  iUnit ȵλ("PDSUnit.h"ļڳȵλĺ궨)
double InternalUnitToDouble(int iValue, int idpmm, int iUnit);

#endif
