#if !defined (READAUTCAD_H)
#define READAUTCAD_H
#pragma once

#include "PDSMath/StdAfx.h"
#include <iostream>
//#include <afxtempl.h>
#include "GroupCode.h"

/////////////////////////////////Start: CDimension/////////////////////////////////////////
//ע룬 Ŀǰֻʶһֱע
class CDimension : public CGroupCode
{
public:
  int m_iType; // -1 =  ʼֵ
  // 0  = תǱעˮƽעֱע
  // 1  = ע
  // 2  = Ƕȱע
  // 3  = ֱע
  // 4  = 뾶ע
  // 5  = Ƕע 
  // 6  = ע
  // 32 = עϢڸĿ
  CString m_strBlockName;

  CPointData m_ptLU;  //ʾλ

  //עʾλ
  CPointData m_ptPoint0;
  CPointData m_ptPoint1;
  CPointData m_ptPoint2;
  CPointData m_ptPoint3;
  CPointData m_ptPoint4;
  CPointData m_ptPoint5;
  CPointData m_ptPoint6;
  BOOL m_bNoString; //=true ʾעûַַҪݼõ false עַΪm_strDimension

  CString m_strDimension;  //ûȷ˱ע֣ѡȱʡֵΪ Ϊջ"<>"ַʽע Ϊ " "һո񣩣ֹ
  
public:
  CDimension(void);
  CDimension(CDimension& a);
  ~CDimension(void);
  BOOL operator==(CDimension& a);
  void operator=(CDimension& a);
  void Initial(void);

  //
  //ֵ
  // true ݿ =falseݲ
  BOOL DisPoseReadData();

  //ַ
  //˵
  //ַ"{\fSimSun|b0|i0|c134|p2;}"Ϊ""
  void DisPoseText(CString &strString);

  //עƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //עתַϢ
  //
  //  TextData ַϢ
  void TransText(CTextData &TextData);

};

class CDimensionList : public CList<CDimension,CDimension&>
{
public:
  CDimensionList& operator=(CDimensionList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CDimension& operator[](int iIndex);

  //עλƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);


  //עתַ
  void TransText(CTextDataList &listTextData);

};
//////////////////////////////////End: CDimension////////////////////////////////////////
//////////////////////////////////Start: CSolidInfor////////////////////////////////////////
class CSolidInfor : public CGroupCode
{
public:
  CCurveNotchInfor  m_CurveInfor;

public:
  CSolidInfor(void);
  CSolidInfor(CSolidInfor& a);
  ~CSolidInfor(void);
  void operator=(CSolidInfor& a);
  void Initial(void);

  //ƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  //void SetScale(double dScale);
};

class CSolidInforList : public CList<CSolidInfor,CSolidInfor&>
{
public:
  CSolidInforList& operator=(CSolidInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CSolidInfor& operator[](int iIndex);

  //עλƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //õ
  void GetCurveInforList(CCurveNotchInforList &listCurveInfor);
};
///////////////////////////////////End: CSolidInfor///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//Auto CADпϢ
class CAuBlockInfor : public CObject
{
public:

  CString m_strBlockName;  //Ϊ˼¼BLOCKĿ(2ĺ)
  CString m_strPatternName;  //ֽ
  CString m_strSizeName;  //
  CStringArray m_arrMaterial;  //
  CUIntArray m_arrQuantity;  //ƬϷ  Quantity:<R,L>
  //ֽΪ˷ֹͻʹAutoCADASTM/TIIPļ

  CCurveNotchInforList m_listCurveInfo;  //еϢ
  
  CTextDataList m_listTextData;  //¼־ΪTEXT/MTEXT

  CPointDataList m_listPointInfo;  //е ¼POINT

  CDimensionList m_listDimension;  //עϢ

  CSolidInforList m_listSolidInfor;  //ʵϢ עе

  CInsertDataList m_listInsertData_Block;  //вϢ

  //m_listCurveInfo/m_listArcCircle/m_listEllispseҳֽ
  CPatternBlockList m_listPatternBlock; //ֽ

public:
  CAuBlockInfor(void);
  CAuBlockInfor(CAuBlockInfor& a);
  ~CAuBlockInfor(void);
  void operator=(CAuBlockInfor& a);
  void Initial(void);

  //λƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);


  //жϸÿǷΪտ
  //ֵ
  //  =true ǣ=false
  //˵
  //  տûκݣΪ
  BOOL IsEmptyBlock();

  //õֽ飬Ϣm_listPatternBlock
  void GetPatternBlock();
private:

  //õֽ
  //:
  //  listAllCurveInfor 
  //  listTextData 
  //
  //  listPatternBlock ֽ
  void GetPatternBlock(CCurveNotchInforList &listAllCurveInfor, CTextDataList &listTextData, CPointDataList &listPointInfo, CPatternBlockList &listPatternBlock);
};

class CAuBlockInfoList : public CList<CAuBlockInfor,CAuBlockInfor&>
{
public:
  CAuBlockInfoList& operator=(CAuBlockInfoList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CAuBlockInfor& operator[](int iIndex);

  //ݸĿҳӦĿ
  //[] strBlockName 
  //[] BlockInfor ҵĿ
  //ֵ
  //  ҵλã ûҵNULL
  POSITION FindBlockName(CString strBlockName, CAuBlockInfor &BlockInfor);

  //עλƫ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(0,0), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //ɾտ飨ûκݵĿ飩
  void DeleteEmptyBlock();

  //õֽ
  void GetPatternBlock();
};
//////////////////////////////////////////////////////////////////////////
//TABLE ->LTYPE
class CLTypeInfor : public CObject
{
public:
  //˵ AutoCADļͶͨűʾģﶼʹַ
   CString m_strLTypeName;  //
   CString m_strDescribe;  //
public:
  CLTypeInfor(void);
  CLTypeInfor(CLTypeInfor& a);
  ~CLTypeInfor(void);
  void operator=(CLTypeInfor& a);
  void Initial(void);
};

class CLTypeInforList : public CList<CLTypeInfor,CLTypeInfor&>
{
public:
  CLTypeInforList& operator=(CLTypeInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CLTypeInfor& operator[](int iIndex);
};
//////////////////////////////////////////////////////////////////////////
//TABLE ->LAYER
class CLayerInfor : public CObject
{
public:
  //˵ AutoCADļͶͨűʾģﶼʹַ
  CString m_strLayerName;  //ͼ
  int m_iStandard;  //׼־ֵ
  /*
  m_iStandard ׼־ֵ(λֵ)
  1 = ͼ㣬ͼⶳ
  2 = ӿȱʡΪͼ
  4 = ͼ
  */
  CString m_strColor;  //ɫ
  CString m_strLineType;  //

public:
  CLayerInfor(void);
  CLayerInfor(CLayerInfor& a);
  ~CLayerInfor(void);
  void operator=(CLayerInfor& a);
  void Initial(void);
};
class CLayerInforList : public CList<CLayerInfor,CLayerInfor&>
{
public:
  CLayerInforList& operator=(CLayerInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CLayerInfor& operator[](int iIndex);

  //ĲӦɫ
  //
  //  strLayerName 
  //ֵ
  //  ӦɫûΪ
  CString FindColor(CString strLayerName);

};

//////////////////////////////////////////////////////////////////////////
class CAuTableInfor : public CObject
{
public:
  //˵ AutoCADļͶͨűʾģﶼʹַ
  CLTypeInforList m_listLType;  //ʶ LTYPE  ļ
  CLayerInforList m_listLayer;  //ʶ LAYER  ļͼϢ Entities԰бûеͼϢ

public:
  CAuTableInfor(void);
  CAuTableInfor(CAuTableInfor& a);
  ~CAuTableInfor(void);
  void operator=(CAuTableInfor& a);
  void Initial(void);
};

//////////////////////////////////////////////////////////////////////////
class CAutoCADFileInfo : public CObject
{
public:
  CAuBlockInfoList m_listBlockInfor;
  CAuBlockInfor m_EntitiesInfor;

  //Ϣ
  CAuTableInfor  m_TableInfor;  //Ϣ TABLES

public:
  CAutoCADFileInfo(void);
  CAutoCADFileInfo(CAutoCADFileInfo& a);
  ~CAutoCADFileInfo(void);
  void operator=(CAutoCADFileInfo& a);
  void Initial(void);

  //õֽ
  //m_listBlockInfor/m_EntitiesInforϢתCPatternBlockList
  void GetPatternBlock();

  //ȥزõBLOCK
  void RemoveUnUseBlock();
};
/*
˵
 1.вתֻǽļе갴ԭ;

*/
class CReadAutoCAD: public CObject
{
public:
  CAutoCADFileInfo m_FileInfo;  //ļ
private:
  FILE *m_pDXFFile;   //ļָ
  BOOL m_bReadWindowText;  //=ture Window/Dosıļ=false Unix/Linuxıļ

  CString m_strValue1, m_strValue2;  //ڶ

  BOOL m_bPattern;  //=trueҪֽ=false ṹ

  BOOL m_bReadSolid;  //=trueʶߣ=false 
public:
  CReadAutoCAD(void);
  ~CReadAutoCAD(void);

  //ļ
  //
  //  strFilePath ļ·
  //  bPattern = true ֽ=false ṹ
  //  bReadSolid = trueʶߣ=false  20210902 XQ
  BOOL ReadAutoCADFile(CString strFilePath, BOOL bPattern, BOOL bReadSolid);

private:

  //
  //[] fFile ļ
  //[] strString1/strString2 
  void ReadGroupString(FILE *fFile, CString &strString1, CString &strString2);

  //
  // ֵ
  // =true ݳɹ=false ʧ
  //˵
  //ݴm_FileInfo
  BOOL ReadFileData();

  //TABLEϢ
  //  TableInforTABLEϢ
  // ֵ
  // =true ݳɹ=false ʧ
  //˵
  // ںвܶTableInforʼ
  BOOL ReadTableData(CAuTableInfor &TableInfor);

  //ʶLAYER
  BOOL ReadLayerData(CLayerInfor &LayerInfor);

  //ʶLTYPE
  BOOL ReadLTypeData(CLTypeInfor &LTypeInfor);

  //BLOCKϢ
  //  BlockInforBLOCKϢ
  //  bReadBlock =true BLOCK=falseENTITIES
  // ֵ
  // =true ݳɹ=false ʧ
  BOOL ReadBlockData(CAuBlockInfor &BlockInfor, BOOL bReadBlock);

  //ʶARCϢ
  BOOL ReadArcData(CCurveNotchInfor &ArcCircleData);

  //ʶCIRCLEϢ
  BOOL ReadCircleData(CCurveNotchInfor &ArcCircleData);

  //ʶELLIPSEϢ
  BOOL ReadEllipseData(CCurveNotchInfor &EllipseData);

  //ʶLINEϢ
  BOOL ReadLineData(CCurveNotchInfor &CurveInfor);

  //ʶMLINEϢ
  BOOL ReadMLineData(CCurveNotchInfor &CurveInfor);

  //ʶPOLYLINEϢ
  BOOL ReadPolylineData(CCurveNotchInfor &CurveInfor);

  //ʶLWPOLYLINEϢ
  BOOL ReadLWPolylineData(CCurveNotchInfor &CurveInfor);

  //ʶSPLINEϢ
  BOOL ReadSPLineData(CCurveNotchInfor &CurveInfor);

  //ʶTEXTϢ
  BOOL ReadTEXTData(CTextData &TextData);

  //ַǷΪֽƻߺ
  //[] strRef οַ
  //[] strName   ֵֻڷֵ0ʱЧ
  //ֵ
  // =0 κ
  // =1 ֽ
  // =2 
  // =3 
  // =4 Ϸ
  int NameSizeInfor(CString strRef, CString &strName);

  //ʶMTEXTϢ
  BOOL ReadMTEXTData(CTextData &TextData);

  //ʶPOINTϢ
  BOOL ReadPointData(CPointData &PointData);

  //ʶDIMENSIONϢ
  BOOL ReadDimensionData(CDimension &Dimension);

  //ʶSOLIDϢ
  BOOL ReadSolidData(CSolidInfor &SolidInfor);

  //ʶINSERTϢ
  BOOL ReadInsertData(CInsertData &InsertData);

  //SPline
  //  pBlockInfor ҪSPlineĿ
  void CalcuateSPlineCurve(CAuBlockInfor *pBlockInfor);
};

#endif

