#if !defined (WRITEDXFFILE_H)
#define WRITEDXFFILE_H

#include "StdAfx.h"
#include <iostream>
#include <afxtempl.h>

//
#define POINT_TURN   0
#define POINT_CURVE  1
#define POINT_ARC    2

//
#define  CURVE_POLYLINE    0
#define  CURVE_ARC         1
#define  CURVE_CIRCLE      2
#define  CURVE_SPLINE      3  //ֻAutoCAD


//
#define NOTCH_T  0
#define NOTCH_I  1
#define NOTCH_U  2
#define NOTCH_V  3

//ʽϢ
class CWriteStyleInfo : public CObject
{
public:
  CPoint m_ptDesignOffset;  //ʽʼ(ϵͳ)
  CString m_strStyleName;
  CString m_strBaseSizeName;
  CList<CString, CString> m_listAllSize;

  CWriteStyleInfo(void);
  CWriteStyleInfo(CWriteStyleInfo& a);
  ~CWriteStyleInfo(void);

  void operator=(CWriteStyleInfo& a);
  void Initial(void);
};
/////////////////////////////////////////////////////////////////////////
class CPointIData : public CObject
{
public:
  CPoint m_ptPoint;
  int m_iGradeIndex;
  int m_iPointType;  //POINT_TURN

public:
  CPointIData(void);
  CPointIData(CPointIData& a);
  ~CPointIData(void);

  void operator=(CPointIData& a);
  void Initial(void);
};
class CPointIDataList : public CList<CPointIData,CPointIData&>
{
public:
  CPointIDataList& operator=(CPointIDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CPointIData& operator[](int iIndex);
};
//////////////////////////////////////////////////////////////////////////
class CCurveIData : public CObject
{
public:
  CPointIDataList m_listCtrlPoint;  //Ƶ
  CList<CPoint, CPoint> m_listActualPoint;  //ʵʵ

  BOOL m_bClose;  //=trueպϣ=false 
  int m_iCurveType;  //=CURVE_ARC, CURVE_CIRCLE, CURVE_POLYLINE
  int m_iDrawType;  //
  COLORREF m_crColor;  //ɫ
  int m_iLayer;  //ڵĲ

  //˵:
  /*  ȷ:
  CURVE_ARC  m_listCtrlPoint ΪƵ㣬 m_listActualPointΪʵʵ
  CURVE_CIRCLE  m_listCtrlPoint ΪƵ㣬 m_listActualPointΪʵʵ
  CURVE_POLYLINE m_listCtrlPointΪƵ㣬 m_listActualPointΪʵʵ  m_listCtrlPointm_listActualPointֵһ

  CURVE_SPLINEָAutoCAD
  CURVE_SPLINE   m_listCtrlPointΪ߾ĿƵ㣬 m_listActualPointΪ߲ĿƵ㣬  m_listActualPointĸm_listCtrlPoint* 4 - 4
  */
public:
  CCurveIData(void);
  CCurveIData(CCurveIData& a);
  ~CCurveIData(void);

  void operator=(CCurveIData& a);
  void Initial(void);

private:
  void CopyData(CCurveIData &a);
};

class CCurveIDataList : public CList<CCurveIData,CCurveIData&>
{
public:
  CCurveIDataList& operator=(CCurveIDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CCurveIData& operator[](int iIndex);

  //õпƵ㣬 ظ
  //
  //  listPointData пƵ㣬Ƶ˳˳
  void GetCtrlPointIData(CPointIDataList &listPointData);

  //õʵʵ㣬 ظ
  //
  //  listPoint ʵʵ㣬ʵʵ˳˳
  void GetActualPoint(CList<CPoint, CPoint> &listPoint);
};
//////////////////////////////////////////////////////////////////////////
//
class CTextIData : public CObject
{
public:
  CPointIData m_PointData;
  CString m_strText;
  double m_dHeight;  //λ mm
  double m_dAngle;  //ˮƽĽǶ
public:

  CTextIData(void);
  CTextIData(CTextIData& a);
  ~CTextIData(void);
  void operator=(CTextIData& a);
  void Initial(void);
};
class CTextIDataList : public CList<CTextIData,CTextIData&>
{
public:
  CTextIDataList& operator=(CTextIDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CTextIData& operator[](int iIndex);
};
//////////////////////////////////////////////////////////////////////////
//Ϣ
class  CDrillIData : public CObject
{
public:
  CPointIData m_ptDrill;

public:
  CDrillIData(void);
  CDrillIData(CDrillIData& a);
  ~CDrillIData(void);
  void operator=(CDrillIData& a);
  void Initial(void);
};

class CDrillIDataList : public CList<CDrillIData,CDrillIData&>
{
public:
  CDrillIDataList& operator=(CDrillIDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CDrillIData& operator[](int iIndex);
};

//////////////////////////////////////////////////////////////////////////
//Ϣ
class  CNotchIData : public CObject
{
public:
  BOOL m_bBorder;  //=true ߼ڣ=false ݼ
  CPointIData m_ptNotch;
  int m_iType;  //,Ĳ 480,81,82,83
  int m_iWidth;  // ڿ ϵͳλ
  int m_iHeight;  // ϵͳλ
  BOOL m_bAngle;  //=trueڽǶ=falseڽǶȲ
  double m_dAngle;  //ڽǶȣXǶ

public:
  CNotchIData(void);
  CNotchIData(CNotchIData& a);
  ~CNotchIData(void);
  void operator=(CNotchIData& a);
  void Initial(void);
};

class CNotchIDataList : public CList<CNotchIData,CNotchIData&>
{
public:
  CNotchIDataList& operator=(CNotchIDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CNotchIData& operator[](int iIndex);

  //ݸҵӦ
  //
  //  ptPoint ڵ
  //ֵ
  // == NULL ûҵ=false ҵ
  POSITION FindNotch(CPoint ptPoint);

  //ұ/ϵļ
  //
  //  bBorder = true ߣ=false 
  //
  //  listNotch Ӧϵļ
  void GetNotch(BOOL bBorder, CNotchIDataList &listNotch);
};

//////////////////////////////////////////////////////////////////////////
//˵ 
//  AutoCADʱֻm_listBorder/m_listSeam/m_listAssistantCurve/m_listText/ m_ptOffset/m_dAngle
class CPatternData : public CObject
{
public:
  CString m_strBlockName;  //
  CString m_strPatternName;  //ֽ
  CString m_strSizeName;  //
  CString m_strComment;   //עCOMMENT/ANNOTATION
  CStringArray m_arrMaterial;  //
  CUIntArray m_arrQuantity;  //ƬϷ  Quantity:<R,L>
  CUIntArray m_arrLQuantity;  //ƬϷ  Quantity:<R,L>
  //m_arrQuantity, m_arrLQuantityСһ

  BOOL m_bFlip;  //תϢ =true ת 
  double m_dRotation;  //б Rotation<0...360>
  BOOL m_bFold;  //۵ Fold:<Y/N> =true ۵
  double m_dTilt;  //бǶ Tilt:<+/-0..90>

  CCurveIDataList m_listBorder;  //
  CCurveIDataList m_listSeam;  //
  CCurveIDataList m_listAssistantCurve;  //
  CTextIDataList m_listText;  //ַ

  CNotchIDataList m_listNotch;  //  ڵڿƵϣҪȻûȥ
  CDrillIDataList m_listDrill;  //

  CCurveIData m_GrainLine;  //
  CCurveIData m_SymmetryLine;  //Գ

  //ֽƫƺתǶȣתΪCPoint(0,0), ˮƽΪ
  CPoint m_ptOffset;
  double m_dAngle;
public:
  CPatternData(void);
  CPatternData(CPatternData& a);
  ~CPatternData(void);
  void operator=(CPatternData& a);
  void Initial(void);
private:
  void CopyData(CPatternData &a);
};

class CPatternDataList : public CList<CPatternData,CPatternData&>
{
public:
  CPatternDataList& operator=(CPatternDataList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CPatternData& operator[](int iIndex);

  //ÿ
  //˵
  // Ŀǰб
  void SetBlockName();

};

//////////////////////////////////////////////////////////////////////////
class CWriteDxfData : public CObject
{
public:
  int m_iDPMM;

  //ʽϢʽϢ
  CWriteStyleInfo m_StyleInfo;
  //ṹϢ
  CCurveIDataList m_listCurveOfFile;  //ļеϢ
  CTextIDataList m_listTextOfFile;  //ļַϢ

  //ֽϢ
  CPatternDataList m_listPattern;  //ֽ
  // ñֻжrulļ
  int m_iGradeCount;  //
  int m_iSizeCount;  //͸
  //m_iSizeCount, m_iGradeCountֻm_RulData
  CPoint **m_pRulData;  //m_RulData[iSizeIndex][iGradeIndex]

public:
  CWriteDxfData(void);
  CWriteDxfData(CWriteDxfData& a);
  ~CWriteDxfData(void);

  void operator=(CWriteDxfData& a);
  void Initial(void);

private:
  void DeleteElta();

  void CopyData(CWriteDxfData &a);

};

//дļ
//
// strPath;  ļȫ·
// iFileType; = 0 ASTMļ= 1 AAMAļ;  =2 AutoCADļ
// Data 
// bAutoCADVer15 =trueR15 ƵSpline=falseR12 ʵʵ, ֻAutoCAD
//ֵ:
//  =true ȷ=false·޷
//˵
//  λmm
BOOL WriteFile( CString strPath, int iFileType, CWriteDxfData &Data, BOOL bAutoCADVer15);


//ֽת豸
//
//  ptPoint ֽ
//
//  fx, fy Ӧ豸XYֵ
void PttnToDP(double dScale, CPoint ptOffset, CPoint ptPoint, float &fx, float &fy);

#endif