#if !defined(DxfMath_h)
#define DxfMath_h

#include <math.h>
#include <afxwin.h>
#include <afxtempl.h>

#include "GroupCode.h"

#define CONST_PI 3.14159265359

//ת
//:
//    (dX,dY)ת,(dXO,dYO)תԭ,dSinBeta,dCosBetaʱתǶȵ
//:
//    (dXNew,dYNew)תֵ
void PointRotate_D(double dX,double dY,double dXO,double dYO,double dSinBeta,double dCosBeta,double& dXNew,double& dYNew);

//ת
//:
//    pdPointת,pdPointOתԭ,dSinBeta,dCosBetaʱתǶȵ
//:
//    pdPointתֵ
void PointRotate(CPointData &pdPoint,CPointData pdPointO,double dSinBeta,double dCosBeta);

//
//ֵ
//  dLength ˫ֵ
double TwoPointLength(CPointData pdPoint1,CPointData pdPoint2);


//ʸpdPointS1pdPointE1ʱ뷽תʸpdPointS2pdPointE2ķļн,[0,2pi)֮
//:
//  pdPointS1,pdPointE1 ʸpdPointS1pdPointE1
//  pdPointS2,pdPointE2 ʸpdPointS2pdPointE2
//ֵ:
//  н
double angle_2(CPointData pdPointS1,CPointData pdPointE1,CPointData pdPointS2,CPointData pdPointE2);

//õpdPoint1pdPoint2м pdMiddle
void GetMiddlePoint(CPointData pdPoint1, CPointData pdPoint2, CPointData &pdMiddle);

//ֱ pdPoint0, pdPoint1򣬵pdPoint0Ϊ dDistance ĵ
CPointData GetPointOnLine(CPointData pdPoint0, CPointData pdPoint1, double dLength);

int IntTrans(double x);

//һ
//:
//  listPoint .
//:
//  .
//ֵ:
//  .
//˵:
//  Ϊ.
//  ϵ.
double Area(CPointDataList& listPoint);

//point߶ptSptEϵĲֵ
//:
//  point .
//  (ptS,ptE) ߶.
//:
//  .
//ֵ:
//  [0,1]߶,Ҿ֮;,߶εӳ.
//˵:
//  ߶ε˵㲻Ӧ.
//  Ӧ,˺ж.
double PointToParam(CPointData& point, CPointData& ptS, CPointData& ptE);

//һ㵽һ߶εĴ.
//:
//  ߶(ptS,ptE)
//  ptRes .
//:
//  ptDes .
//ֵ:
//  .
//˵:
//  ߶ε˵㲻Ӧͬ,㸳ֵͬ.
//  δ߶.
void GetVerticalPoint(CPointData& ptS, CPointData& ptE, CPointData& ptRes, CPointData& ptDes);

//ж߶Ƿƽ
//:
//  ߶(ptS0,ptE0),(ptS1,ptE1)
//:
//  .
//ֵ:
//  =TRUE,ƽ;=FALSE,߲ƽ.
//˵:
//  ÿ߶ε˵㶼Ӧͬ,Щ,Ϊƽ.
BOOL IsParallel(CPointData& ptS0, CPointData& ptE0, CPointData& ptS1, CPointData& ptE1);

//һ㵽һľ.
//:
//  point .
//  listPoint .
//:
//  .
//ֵ:
//  .㵽߶ξеСֵ.
//˵:
double DistanceFromPointToList(CPointData& point, CPointDataList& listPoint);

//ԲƵ
//
//  dAngleS ԲʼǶ  οˮƽ
//  dAngleE ԲǶ  οˮƽ
//  PDCenter Բ
//  dRadius 뾶
//
//  listCtrlPoint ԲĿƵ
void CalculateArcPoint(double dAngleS, double dAngleE, CPointData PDCenter, double dRadius, CPointDataList &listCtrlPoint);

//ԲƵ
//
//  PDCenter Բ
//  dRadius 뾶
//
//  listCtrlPoint ԲĿƵ
void CalculateCirclePoint(CPointData PDCenter, double dRadius, CPointDataList &listCtrlPoint);

//ԲƵ
//
//  dAngleS dAngleE ʼǶ  dAngleSdAngleEΪ360ȣʾΪԲ  dAngleE > dAngleS ˳룬֮Ϊʱ
//  PDCenter Բĵ
//  PDAxis  Բһ˵㣨ĵ㣩
//  dProportion  //Ͷ
//
//  listCtrlPoint Ƶ
//ֵ
//  ֻ2Ч=true Բ=false Բ
BOOL CaculateEllipse(double dAngleS, double dAngleE, CPointData PDCenter, CPointData PDAxis, double dProportion, CPointDataList &listCtrlPoint);


//ɾغ
//[][] listAllCurveInfor , Ҫûбպ
void DeleteSameCurve(CCurveNotchInforList &listAllCurveInfor);

//ɾCurveInforغ(ȫغ)
//[][] CurveInfor 
//[][] listAllCurveInfor ,:غϵ߱ɾ
void FindSameCurveAndDelete(CCurveNotchInfor &CurveInfor, CCurveNotchInforList &listAllCurveInfor);

//ڸѰбպ
//[][] listAllCurveInfor    ʱûlistAllCloseCurveе
//[] listAllCloseCurve еıպ
//[] iFileType ļ  =0 AutoCADļ =1 AAMA/ASTM/TIIP
void GetAllCloseCurve(CCurveNotchInforList &listAllCurveInfor, CCloseCurveInforList &listAllCloseCurve, int iFileType);

//ڸѰұպϵ
//[][] listAllCurveInfor    ʱûCloseCurveInfoе
//[] CloseCurveInfo պϵ ֵΪtrueЧ
//[] CurveInforFirst ҵպߵĿʼֵΪfalseЧ
//ֵ
// =true ҵ=falseûҵ
BOOL GetCloseCurve(CCurveNotchInforList &listAllCurveInfor, CCloseCurveInfor &CloseCurveInfo, CCurveNotchInfor &CurveInforFirst);

//ҿƵĵ
//[][]  listAllCurveInfor е вMaxCtrlCurveInfor
//[]  MaxCtrlCurveInfor Ƶĵ
void FindCtrlMaxCount(CCurveNotchInforList &listAllCurveInfor, CCurveNotchInfor &MaxCtrlCurveInfor);

//Ѱҿʼ,õߵ
void FindStartCurve(CCurveNotchInforList &listAllCurveInfor, CCurveNotchInfor &StartCtrlCurveInfor);

//ѰҶԽӵһ
//[][] listAllCurveInfor е вCurveInforNext
//[] listRefCurveInfor οѾγɵ
//[] JointPointData Խӵ
//[] dSamePointDistance ͬ
//[] CurveInforNext ҵĶԽ
//[] bHead=trueʾCurveInforNextͷͬ
//ֵ
// =true ҵ=false ûҵ
BOOL FindJointPoint(CCurveNotchInforList &listAllCurveInfor, CCurveNotchInforList &listRefCurveInfor, CPointData JointPointData, double dSamePointDistance, CCurveNotchInfor &CurveInforNext, BOOL &bHead);

//20200226 жCurveInforlistRefCurveInforǷص
//
//  listRefCurveInfor ο߶
//  CurveInfor ж߶
//ֵ:
// =true ص =false ص
BOOL OverlapList(CCurveNotchInforList &listRefCurveInfor, CCurveNotchInfor CurveInfor);

//ڸĵѰͷ/βͬ
//[][] listAllCurveInfor е вlistSamCurveInfor
//[] RefPointData ο
//[] dSamePointDistance ͬ
//[] listSameCurveInforͬ, ͷοͬ
void FindSamePoint(CCurveNotchInforList &listAllCurveInfor, CPointData &RefPointData, double dSamePointDistance, CCurveNotchInforList &listSameCurveInfor);

//Ҹеĸ
//[][] listAllCurveInfor    ʱûlistAssistantCurveе
//[][] listCloseCurveInfor    ʱûlistAssistantCurveе
//[] listBorder ʵʵ
//[] listAssistantCurve 
void FindPatternAssistanceCurve(CCurveNotchInforList &listAllCurveInfor, CCloseCurveInforList &listCloseCurveInfor, CList<CPoint, CPoint> &listBorder, CCurveNotchInforList &listAssistantCurve);

//Ҹеַ
//[][] listAllTextData ַ   ʱûlistTextеַ
//[] listBorder ʵʵ
//[] listText 
void FindPatternText(CTextDataList &listAllTextData, CList<CPoint, CPoint> &listBorder, CTextDataList &listText);

//Ҹֽеĵ
//[][] listPointData е   ʱûֽе
//[] listBorder
//[] listAssistantPoint 
void FindPatternPoint(CPointDataList &listPointData, CList<CPoint, CPoint> &listBorder, CCurveNotchInforList &listAssistantPoint);

#endif