#if !defined (READASTM_H)
#define READASTM_H
#pragma once

#include "PDSMath/StdAfx.h"
#include <iostream>
//#include <afxtempl.h>
#include "GroupCode.h"


//ĳ߲Ϣ
class CCurveLayerInfor : public CObject
{
public:
  CCurveNotchInforList m_listCurveLayer;  //ԲԲתɿƵ
  CCurveNotchInforList m_listCurveCheckLayer;  //òУ ԲԲתɿƵ
  CPointDataList m_listTurnPointLayer;  //òת۵ ¼POINT  ñSPline ԲԲԲЧ
  CPointDataList m_listCurvePointLayer;  //òߵ ¼POINT  ñSPlineԲԲԲЧ
  CTextDataList m_listPointGrade;  //¼־ΪTEXT/MTEXTķ

public:
  CCurveLayerInfor(void);
  CCurveLayerInfor(CCurveLayerInfor& a);
  ~CCurveLayerInfor(void);
  void operator=(CCurveLayerInfor& a);
  void Initial(void);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  //void SetScale(double dScale);

  //òеĵͺͷID
  //
  //  listPointGrade 
  //  listTurnPointLayer ת۵
  //  listCurvePointLayer ߵ
  //˵
  //  Ȳthisеûڴв
  void SetPointTypeGradeID(CTextDataList &listPointGrade, CPointDataList &listTurnPointLayer, CPointDataList &listCurvePointLayer);

private:

  //Чȷߵ
  //ڵlistAllValidatePointеûlistAllPointеĵ뵽listCurvePoint
  //:
  //  listAllPoint ߲
  //  listAllValidatePoint У
  //:
  //  listCurvePoint ߵ
  void FindCurvePoint(CPointDataList &listAllPoint, CPointDataList &listAllValidatePoint, CPointDataList &listCurvePoint);

};

//AAMA/ASTMĿϢ
class CAMBlockInfor : public CObject
{
public:

  //ļж
  CString m_strBlockName;  //Ϊ˼¼BLOCKĿ(2ĺ)

  CString m_strPatternName;  //ֽ
  CString m_strSizeName;  //
  BOOL m_bBaseSize;  //=true ʾΪ룻=false ǣ ڿʽϢûжʹã ĬFalse
  CString m_strComment;   //עCOMMENT/ANNOTATION
  
  CStringArray m_arrMaterial;  //
  CUIntArray m_arrQuantity;  //ƬϷ  Quantity:<R,L>
  CUIntArray m_arrLQuantity;  //ƬϷ  Quantity:<R,L>
  //m_arrQuantity, m_arrLQuantityСһ

  BOOL m_bFlip;  //תϢ =true ת 
  double m_dRotation;  //б Rotation<0...360>
  BOOL m_bFold;  //۵ Fold:<Y/N> =true ۵
  double m_dTilt;  //бǶ Tilt:<+/-0..90>

  CCurveLayerInfor m_Layer1;  //1㣬 
  CCurveLayerInfor m_Layer14;  //14㣬
  CCurveLayerInfor m_Layer8;  //8㣬
  CCurveLayerInfor m_Layer11;  //11 ڲü

  CCurveNotchInfor m_CurveLayer5;  //
  CCurveNotchInfor m_CurveLayer6;  //Գ
  CCurveNotchInfor m_CurveLayer7;  //
  CCurveNotchInforList m_listCurveLayer910;  //

  CCurveLayerInfor m_Layer;  //֮в, ԲԲתɿƵ, m_listTurnPointLayer/m_listCurvePointLayer/m_listPointGradeŸÿжз㣬ת۵㣬ߵ

  CTextDataList m_listTextData;  //¼־ΪTEXT/MTEXT  T
  //CNotchInforList m_listNotchInfo;  //Ϣ
  CDrillInforList m_listDrillInfo;  //13CircleʶϢ

  CInsertDataList m_listInsertData_Block;  //вϢ
public:
  CStringArray m_arrCategory;  //20180614 ¼CATEGORYֶΣCATEGORYΪϻעͣ ʱⱣ
public:
  CAMBlockInfor(void);
  CAMBlockInfor(CAMBlockInfor& a);
  ~CAMBlockInfor(void);
  void operator=(CAMBlockInfor& a);
  void Initial(void);

  //λƫƺͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  //void SetScale(double dScale);

  //ÿеĵͺͷID
  //[] bAllInfor = trueʹв;=falseʹöӦ
  void SetPointTypeGradeID(BOOL bAllInfor);

  //20180614 жm_arrCategoryǷΪǷm_arrMaterialǷm_strComment
  void DisposeMaterilaName();

private:

  void CopyBlockInfor(CAMBlockInfor &a);

};

class CAMBlockInforList : public CList<CAMBlockInfor,CAMBlockInfor&>
{
public:
  CAMBlockInforList& operator=(CAMBlockInforList& rhs);  // ֵ

  //ȡֵָϵ
  //:
  //  iIndex  ֵ,0ʼ,Խ
  //ֵ:
  CAMBlockInfor& operator[](int iIndex);

  //λƫ,תͷ
  //
  //dOffsetX/dOffsetY ƫ
  //dSin/dCos תǶȣ תΪCPoint(dOffsetX, dOffsetY), ˮƽΪ
  //dScaleX/dScaleY ŴС  20220408 XQ
  //˵
  //  ƫ->ת->ŴС
  void SetRotateOffset(double dOffsetX, double dOffsetY, double dSin, double dCos, double dScaleX, double dScaleY);

  //÷Ŵ
  //
  //dScale ŴС
  //void SetScale(double dScale);

  //ÿеĵͺͷID
  //[] bAllInfor = trueʹв;=falseʹöӦ
  void SetPointTypeGradeID(BOOL bAllInfor);

  //滻ɸַ
  //
  //  strOldSizeName ɺ
  //  strNewSizeName º
  void ReplaceSizeName(CString strOldSizeName, CString strNewSizeName);

  //ڸƵĺͶӦֽ
  //
  // strSizeName Ҫҵ
  //
  // listBlockInfor ҵֽб
  //ֵ
  // =true ҵ=false ûҵ
  BOOL FindSizeName(CString strSizeName, CAMBlockInforList &listBlockInfor);
};


//ļе
class CRulInfor : public CObject
{
public:
  BOOL m_bReadRul;  //=true ʾrulļ

  int m_iUnit;  //= CONST_MM METRICmm= CONST_INCH  ENGLISH : Ӣ磻 Ĭmm

  int m_iSizeCount;  //͸
  CString m_strSampleSize;  //
  CList<CString, CString> m_listAllSize;  //к  Сm_iSizeCountһ

  int m_iGradeCount;  //
  CPointData **m_pRulData;  //m_RulData[iSizeIndex][iGradeIndex]

public:
  CRulInfor(void);
  CRulInfor(CRulInfor& a);
  ~CRulInfor(void);
  void operator=(CRulInfor& a);
  void Initial(void);

  //
  //
  //dScale ŴС
  //˵
  // Ҫƫƣ
  void SetScale( double dScale);

private:
  void DeleteElta();

};

//EntitiesϢ
class CAMEntitiesInfor : public CObject
{
public:
  CString m_strStyleName;  //Style Name:<string>
  CString m_strSampleSize;  //Sample Size:<string>
  int m_iUnit;  //= CONST_MM METRICmm= CONST_INCH  ENGLISH : Ӣ磻 Ĭmm
  CString m_strGradeRulTable;  //ļrul  Grade Rule Table:<string>
  CString m_strAuthor;  //Author:<Vendor name>;<application>;<release #
  CString m_strVersion;  //汾
  CInsertDataList m_listInsertData;

public:
  CAMEntitiesInfor(void);
  CAMEntitiesInfor(CAMEntitiesInfor& a);
  ~CAMEntitiesInfor(void);
  void operator=(CAMEntitiesInfor& a);
  void Initial(void);
};

class CASTMFileInfor : public CObject
{
public:

  // ע⣺
  //m_listBlockInfor m_listSameSizeBlockInforеһֻѡһʹ

  //ʼֵΪdxfļжϢ
  CString m_strSampleSize;  //, ڴʱԸñΪ׼
  CList<CString, CString>  m_listAllSize;  //кͣظ ڴʱ͸ԸñΪ׼

  CAMBlockInforList m_listBlockInfor;  //Block
  CAMEntitiesInfor m_EntitiesInfor;  //Entities

  CRulInfor m_rulInfor;  //

public:
  CASTMFileInfor(void);
  CASTMFileInfor(CASTMFileInfor& a);
  ~CASTMFileInfor(void);
  void operator=(CASTMFileInfor& a);
  void Initial(void);
};

//ļ

/*
˵
 1.вתֻǽļе갴ԭ;

*/
class CReadASTMFile: public CObject
{
public:
  CASTMFileInfor m_FileInfo;  //ļ
private:
  FILE *m_pDXFFile;   //ļָ
  BOOL m_bReadWindowText;  //=ture Window/Dosıļ=false Unix/Linuxıļ

  CString m_strFileName;  //ȡļͬʱҲΪļ

  CString m_strValue1, m_strValue2;  //ڶ

  BOOL m_bOnlyReadBaseSize;  //true 
  BOOL m_bPattern;  //=true ֽ=false ṹ

  int  m_iAllInfor;  //ȷת۵ = -1 ûȷ 0 ʹв;=1ʹöӦ
public:
  CReadASTMFile(void);
  ~CReadASTMFile(void);

  //ļ
  //:
  //  strFilePath ļ·
  //  bPattern =true ֽ false ṹߣ ṹ߲örul
  //  bOnlyReadBaseSize =true 룬 ֽЧ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  int ReadASTMFile(CString strFilePath, BOOL bPattern, BOOL bOnlyReadBaseSize);

protected:

  //20200903 XQ  һı
  void ReadAString(FILE *fFile, CString &strString1);

  //
  //[] fFile ļ
  //[] strString1/strString2 
  void ReadGroupString(FILE *fFile, CString &strString1, CString &strString2);

  //ļ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  int ReadASTMFile();

  //BLOCKϢ
  //
  //  BlockInfor Ϣ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  //˵
  //  ֵΪ0ʱBlockInforЧ
  int ReadBlock(CAMBlockInfor &BlockInfor);

  //POLYLINE
  //Ϣ
  //  BlockInfor Ϣ
  //  iLayer ڵĲ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  //˵
  //  ֵΪ0ʱBlockInforЧ
  int ReadPolylineData(CAMBlockInfor &BlockInfor, int &iLayer);
  //POLYLINE
  //
  //  CurveInfor Ϣ
  //  listCurvePoint ߵϢ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  //˵
  //  ֵΪ0ʱCurveInforЧ
  int ReadPolylineData(CCurveNotchInfor &CurveInfor, CPointDataList &listCurvePoint);

  //LINE
  //Ϣ
  //  BlockInfor Ϣ
  //  iLayer ڵĲ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AutoCADļ
  //  = 3 TIIPļ
  //˵
  //  ֵΪ0ʱBlockInforЧ
  int ReadLineData(CAMBlockInfor &BlockInfor, int &iLayer);

  //LINE
  int ReadLineData(CCurveNotchInfor &CurveInfor);

  //TEXT
  void ReadTEXTData(CAMBlockInfor &BlockInfor, int iLayer);
  //ʶTEXTϢ
  BOOL ReadTEXTData(CTextData &TextData);

  //ֽϢ
  //
  //  BlockInfor Ϣ
  //  strInformation ֽϢַ
  //ֵ
  //  =trueʾΪֽϢ =false ΪT
  BOOL PatternInfor(CAMBlockInfor &BlockInfor, CString strInformation);

  //POINT
  void ReadPointData(CAMBlockInfor &BlockInfor, int iLayer);

  //
  //
  //  NotchInfor 
  //ֵ
  //= trueã=false
  BOOL ReadNotch(CNotchInfor &NotchInfor);
  //
  //
  //  DrillInfor 
  //ֵ
  //= trueã=false
  BOOL ReadDrill(CDrillInfor &DrillInfor);

  //CIRCLE
  void ReadCircleData(CAMBlockInfor &BlockInfor);

  //ARC
  int ReadArcData(CAMBlockInfor &BlockInfor, int &iLayer);
  //ARC
  BOOL ReadArcData(CCurveNotchInfor &CurveInfor);

  //INSERT
  void ReadInsertData(CAMBlockInfor &BlockInfor);
  BOOL ReadInsertInfor(CInsertData &InsertData);

  //EntitiesϢ
  //
  //  EntitiesInfor Ϣ
  //ֵ:
  //  = 0 ɹ
  //  = 1 ļ򲻿
  //  = 2 AAMA/ASTMļ
  int ReadEntities(CAMEntitiesInfor &EntitiesInfor);

  //ʽϢ
  //
  //  EntitiesInfor Ϣ
  //  strInformation ֽϢַ
  //ֵ
  //  =trueʾΪʽϢ =false 
  BOOL StyleInfor(CAMEntitiesInfor &EntitiesInfor, CString strInformation);

  //ļ
  void ReadRulFile();

  //rulļеķϢ
  void ReadRulSize(FILE *pRulFile);

  //rulļеķ
  void ReadRulGradeValue(FILE *pRulFile);

  //ļ
  void DisposeFileData();

  //ֽߴڶ
  void DisPosePatternBorder();

};
#endif
